#include <iostream>
#include "factory.h"
#include "work_unit.h"

class Fibonacci;
factory<Fibonacci> fibber(LOGICAL, STEAL);

class Fibonacci: public task_unit
{
	private:
		int n;
		int* result;

	public:
		void work_init(int _n, int* _result, Fibonacci* parent)
		{
			task_unit::work_init(parent);
			n = _n;
			result = _result;
		}

		void work()
		{
			if (n < 2) {
				*result = n;
			} else {
				int part1, part2;

				fibber.spawn(n - 1, &part1, this);				
				fibber.spawn(n - 2, &part2, this);
				fibber.child_barrier(this);

				*result = part1 + part2;
			}
		}
};

int main(int argc, char** argv)
{	
	int n, result;

	if (argc != 2) {
		printf("Usage: fib [<cilk options>] <n>\n");
		exit(2);
	}
	n = atoi(argv[1]);

	fibber.start_working();
	barrier_object root = fibber.spawn(n, &result, (Fibonacci*)NULL);
	fibber.root_barrier(root);
	fibber.stop_working();

	std::cout << result << std::endl;
	return 0;
}
