#include <omp.h>

int fibonacci(int n)
{
	if (n < 2) {
		return n;
	} else {
		int part1, part2;

		#pragma intel omp parallel taskq
		{
			#pragma intel omp task
			{
				part1 = fibonacci(n - 1);				
			}

			#pragma intel omp task
			{
				part2 = fibonacci(n - 2);
			}
		}
		return part1 + part2;
	}
}

int main(int argc, char *argv[])
{
	int n, result;

	if (argc != 2) {
		printf("Usage: fib [<cilk options>] <n>\n");
		exit(2);
	}
	n = atoi(argv[1]);

	result = fibonacci(n);

	printf("Result: %d\n", result);
	return 0;
}
