#include <omp.h>

const int N = 1000;

int main(int argc, char** argv)
{
	factory<naive_matmul> multiplier(LOGICAL, FIFO_LOCAL);
	double* one	= new double[N * N];
	double* two	= new double[N * N];
	double* result	= new double[N * N];

	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j) {
			one[i * N + j] = two[i * N + j] = 3;
			result[i * N + j] = 0;
		}
	}

	#pragma omp parallel for
	for (int i = loop_start; i < loop_stop; ++i) {
		for (int j = 0; j < N; ++j) {
			for (int k = 0; k < N; ++k) {
				result[i * N + j] += one[i * N + k] * two[k * N + j];
			}
		}
	}

	return 0;
}
