/*
 * loop.cpp
 *
 * Scott Schneider
 */

#include <iostream>
using namespace std;

#include <cmath>
#include <omp.h>
#include "timing.h"
#include "bindme.h"

const int SAMPLE_SIZE = 500;
int GRANULARITY;		

int main(int argc, char** argv)
{
	if (argc < 3) {
		cout << "usage: loop <# of threads> <# of nops>" << endl;
		exit(1);
	}

	omp_set_num_threads(atoi(argv[1]));
	GRANULARITY = atoi(argv[2]);

	unsigned long long* samples = new unsigned long long[SAMPLE_SIZE];

	unsigned long long sum = 0;
	for (int i = 0; i < SAMPLE_SIZE; ++i) {

		unsigned long long before = 0;
		unsigned long long after = 0;

		//#pragma omp parallel
		//{
			int k;
			//bindme_all_double(omp_get_thread_num(), omp_get_num_threads());

			before = clock_cycles();
			//#pragma omp for private(k) schedule(static)
			for (k = 0; k < 7500; k += 10) {
				asm volatile ("pause");
				asm volatile ("pause");
				asm volatile ("pause");
				asm volatile ("pause");
				asm volatile ("pause");
				asm volatile ("pause");
				asm volatile ("pause");
				asm volatile ("pause");
				asm volatile ("pause");
				asm volatile ("pause");
				// 10
			}
			after = clock_cycles();
		//}

		samples[i] = after - before;
		sum += after - before;
	}

	unsigned long long average = sum / SAMPLE_SIZE;
	unsigned long long variance = 0;
	for (int i = 0; i < SAMPLE_SIZE; ++i) {
		variance += pow((long double)average - samples[i], 2);	
	}
	variance /= SAMPLE_SIZE;

	std::cout	<< "avg:" << average << std::endl
		 	<< "std:" << sqrt((long double)variance) << std::endl;

	return 0;
}

