#include <cmath>
#include <iostream>
#include <time.h>
//#include <linux/prefetch.h>

/*************************************
 *
 *function for getting the number o
 * of the CPU cycles
 *
 *************************************/
unsigned long long int rdtsc(void)
{
   unsigned long long int x;

   __asm__ volatile(".byte 0x0f,0x31" : "=A" (x));
   return x;
}

int main(int argc, char* argv[]) {

    if ((argc > 3) || (argc == 1)) {
        printf("Input the matrix size\n");
        exit(1);
    }
    
    int N=atoi(argv[1]);                      //size of the matrix

    unsigned long long int starttime,endtime;  //variables where the number of
                                               //cycles will be stored
    clock_t beg, end;                          //time variables
    clock_t in_beg, in_end, in_total = 0;
    int in_i = 0;
    
    //if size is less than 20 optimization is
    //blocking with interchanging loops
    if (N<20) {

        double (*a)[N] = new double[N][N];
        double (*b)[N] = new double[N][N];
        double (*c)[N] = new double[N][N];
        int i,j,k,ii,kk,block=5;
    
        //setting mat b
        for( i=0; i<N; i++)
            for( j=0; j<N; j++)
                b[i][j]=3;

    
        //setting mat c
        for( i=0; i<N; i++)
            for( j=0; j<N; j++)
                c[i][j]=3;

   
        //setting mat a
        for( i=0; i<N; i++)
            for( j=0; j<N; j++)
                a[i][j]=0;
        
        double sum=0;
        beg=clock();                              //getting time and number of
        starttime=rdtsc();                        //cycles before the execution
     
        for (ii=0; ii<N; ii+=block) 
            for (kk=0; kk<N; kk+=block) 
                for (i=ii; i<(((ii+block)<N) ? (ii+block):(N)); i++) {
                    for (k=kk; k<(((kk+block)<N) ? (kk+block):(N)); k++) {
                        sum=0;
                        for (j=0; j<N; j++)
                            sum += b[i][k]*c[k][j];
                    }
                    a[i][j]+=sum;
                } 
     
        endtime=rdtsc();                          //getting time and number of
        end=clock();                              //cycles before the execution
    
     printf("\nSize: %d\n",N);
     printf("clocks: %Lu  ",endtime-starttime);
     printf("block: %d\n",block);
     printf("Time %ld\n\n\n",end-beg);
     exit(1);

    }
         
    double c0,c1,c2,c3,c4,c5,c6,c7,c8,c9;    //variables that willbe use
                                             //instead of matrix
    
    int K;
    if(N%20!=0) K=N-N%20+20;                 //setting the new matrix size
    else K=N;                                //if the old one was not
                                             //divisible by 20
   
    double (*a)[K] = new double[K][K];
    double (*b)[K] = new double[K][K];
    double (*c)[K] = new double[K][K];
    long i,j,k;
    
    //setting mat b
    for( i=0; i<N; i++)
	for( j=0; j<N; j++)
            b[i][j]=3;

    
    //setting mat c
    for( i=0; i<N; i++)
	for( j=0; j<N; j++)
	    c[i][j]=3;

   
    //setting mat a
    for( i=0; i<K; i++)
	for( j=0; j<K; j++)
	    a[i][j]=0;

    //adding "zero" rows and columns to the resized matrix
    if (K!=N){             

        beg=clock();                           //getting time and number of
        starttime=rdtsc();                     //cycles before the execution

        for( i=0; i<K; i++)
            for( j=N; j<K; j++)
                b[i][j]=0;

        for( i=N; i<K; i++)
            for( j=0; j<K; j++)
                b[i][j]=0;   
        
        for( i=0; i<K; i++)
            for( j=N; j<K; j++)
                c[i][j]=0;
        
        for( i=N; i<K; i++)
            for( j=0; j<K; j++)
                c[i][j]=0;
    }

        
    if (K==N){
        beg=clock();                           //getting time and number of
        starttime=rdtsc();                     //cycles before the execution
    }

    //calculating multiplication with loop unrooling
    for (i=0; i<K;i+=20) {
	in_beg = time(NULL);
        for (k=0; k<K; k+=10) {

            double r00=b[i][k];
            double r10=b[i+1][k];
            double r20=b[i+2][k];
            double r30=b[i+3][k];
            double r40=b[i+4][k];
            double r50=b[i+5][k];
            double r60=b[i+6][k];
            double r70=b[i+7][k];
            double r80=b[i+8][k];
            double r90=b[i+9][k];
            double r100=b[i+10][k];
            double r110=b[i+11][k];
            double r120=b[i+12][k];
            double r130=b[i+13][k];
            double r140=b[i+14][k];
            double r150=b[i+15][k];
            double r160=b[i+16][k];
            double r170=b[i+17][k];
            double r180=b[i+18][k];
            double r190=b[i+19][k];
           
            double r01=b[i][k+1];
            double r11=b[i+1][k+1];
            double r21=b[i+2][k+1];
            double r31=b[i+3][k+1];
            double r41=b[i+4][k+1];
            double r51=b[i+5][k+1];
            double r61=b[i+6][k+1];
            double r71=b[i+7][k+1];
            double r81=b[i+8][k+1];
            double r91=b[i+9][k+1];
            double r101=b[i+10][k+1];
            double r111=b[i+11][k+1];
            double r121=b[i+12][k+1];
            double r131=b[i+13][k+1];
            double r141=b[i+14][k+1];
            double r151=b[i+15][k+1];
            double r161=b[i+16][k+1];
            double r171=b[i+17][k+1];
            double r181=b[i+18][k+1];
            double r191=b[i+19][k+1];
            
            double r02=b[i][k+2]; 
            double r12=b[i+1][k+2];
            double r22=b[i+2][k+2];
            double r32=b[i+3][k+2];
            double r42=b[i+4][k+2];
            double r52=b[i+5][k+2]; 
            double r62=b[i+6][k+2];
            double r72=b[i+7][k+2];
            double r82=b[i+8][k+2];
            double r92=b[i+9][k+2];
            double r102=b[i+10][k+2]; 
            double r112=b[i+11][k+2];
            double r122=b[i+12][k+2];
            double r132=b[i+13][k+2];
            double r142=b[i+14][k+2];
            double r152=b[i+15][k+2]; 
            double r162=b[i+16][k+2];
            double r172=b[i+17][k+2];
            double r182=b[i+18][k+2];
            double r192=b[i+19][k+2];
           
            double r03=b[i][k+3];
            double r13=b[i+1][k+3];
            double r23=b[i+2][k+3];
            double r33=b[i+3][k+3];
            double r43=b[i+4][k+3];
            double r53=b[i+5][k+3];
            double r63=b[i+6][k+3];
            double r73=b[i+7][k+3];
            double r83=b[i+8][k+3];
            double r93=b[i+9][k+3];
            double r103=b[i+10][k+3];
            double r113=b[i+11][k+3];
            double r123=b[i+12][k+3];
            double r133=b[i+13][k+3];
            double r143=b[i+14][k+3];
            double r153=b[i+15][k+3];
            double r163=b[i+16][k+3];
            double r173=b[i+17][k+3];
            double r183=b[i+18][k+3];
            double r193=b[i+19][k+3];
          
            double r04=b[i][k+4];
            double r14=b[i+1][k+4];
            double r24=b[i+2][k+4];
            double r34=b[i+3][k+4];
            double r44=b[i+4][k+4];
            double r54=b[i+5][k+4];
            double r64=b[i+6][k+4];
            double r74=b[i+7][k+4];
            double r84=b[i+8][k+4];
            double r94=b[i+9][k+4];
            double r104=b[i+10][k+4];
            double r114=b[i+11][k+4];
            double r124=b[i+12][k+4];
            double r134=b[i+13][k+4];
            double r144=b[i+14][k+4];
            double r154=b[i+15][k+4];
            double r164=b[i+16][k+4];
            double r174=b[i+17][k+4];
            double r184=b[i+18][k+4];
            double r194=b[i+19][k+4];
           
            double r05=b[i][k+5];
            double r15=b[i+1][k+5];
            double r25=b[i+2][k+5];
            double r35=b[i+3][k+5];
            double r45=b[i+4][k+5];
            double r55=b[i+5][k+5];
            double r65=b[i+6][k+5];
            double r75=b[i+7][k+5];
            double r85=b[i+8][k+5];
            double r95=b[i+9][k+5];
            double r105=b[i+10][k+5];
            double r115=b[i+11][k+5];
            double r125=b[i+12][k+5];
            double r135=b[i+13][k+5];
            double r145=b[i+14][k+5];
            double r155=b[i+15][k+5];
            double r165=b[i+16][k+5];
            double r175=b[i+17][k+5];
            double r185=b[i+18][k+5];
            double r195=b[i+19][k+5];
        
            double r06=b[i][k+6];
            double r16=b[i+1][k+6];
            double r26=b[i+2][k+6];
            double r36=b[i+3][k+6];
            double r46=b[i+4][k+6];
            double r56=b[i+5][k+6];
            double r66=b[i+6][k+6];
            double r76=b[i+7][k+6];
            double r86=b[i+8][k+6];
            double r96=b[i+9][k+6];
            double r106=b[i+10][k+6];
            double r116=b[i+11][k+6];
            double r126=b[i+12][k+6];
            double r136=b[i+13][k+6];
            double r146=b[i+14][k+6];
            double r156=b[i+15][k+6];
            double r166=b[i+16][k+6];
            double r176=b[i+17][k+6];
            double r186=b[i+18][k+6];
            double r196=b[i+19][k+6];
         
            double r07=b[i][k+7]; 
            double r17=b[i+1][k+7];
            double r27=b[i+2][k+7];
            double r37=b[i+3][k+7];
            double r47=b[i+4][k+7];
            double r57=b[i+5][k+7]; 
            double r67=b[i+6][k+7];
            double r77=b[i+7][k+7];
            double r87=b[i+8][k+7];
            double r97=b[i+9][k+7];
            double r107=b[i+10][k+7]; 
            double r117=b[i+11][k+7];
            double r127=b[i+12][k+7];
            double r137=b[i+13][k+7];
            double r147=b[i+14][k+7];
            double r157=b[i+15][k+7]; 
            double r167=b[i+16][k+7];
            double r177=b[i+17][k+7];
            double r187=b[i+18][k+7];
            double r197=b[i+19][k+7];
            
            double r08=b[i][k+8];
            double r18=b[i+1][k+8];
            double r28=b[i+2][k+8];
            double r38=b[i+3][k+8];
            double r48=b[i+4][k+8];
            double r58=b[i+5][k+8];
            double r68=b[i+6][k+8];
            double r78=b[i+7][k+8];
            double r88=b[i+8][k+8];
            double r98=b[i+9][k+8];
            double r108=b[i+10][k+8];
            double r118=b[i+11][k+8];
            double r128=b[i+12][k+8];
            double r138=b[i+13][k+8];
            double r148=b[i+14][k+8];
            double r158=b[i+15][k+8];
            double r168=b[i+16][k+8];
            double r178=b[i+17][k+8];
            double r188=b[i+18][k+8];
            double r198=b[i+19][k+8];
        
            double r09=b[i][k+9];
            double r19=b[i+1][k+9];
            double r29=b[i+2][k+9];
            double r39=b[i+3][k+9];
            double r49=b[i+4][k+9];
            double r59=b[i+5][k+9];
            double r69=b[i+6][k+9];
            double r79=b[i+7][k+9];
            double r89=b[i+8][k+9];
            double r99=b[i+9][k+9];
            double r109=b[i+10][k+9];
            double r119=b[i+11][k+9];
            double r129=b[i+12][k+9];
            double r139=b[i+13][k+9];
            double r149=b[i+14][k+9];
            double r159=b[i+15][k+9];
            double r169=b[i+16][k+9];
            double r179=b[i+17][k+9];
            double r189=b[i+18][k+9];
            double r199=b[i+19][k+9];
            
       

         
            for(j=0;j<K;j++){

                c0=c[k][j];c1=c[k+1][j];c2=c[k+2][j];c3=c[k+3][j];c4=c[k+4][j];
                c5=c[k+5][j];c6=c[k+6][j];c7=c[k+7][j];c8=c[k+8][j];c9=c[k+9][j];
               
                              
                a[i][j] += r00*c0 + r01*c1 + r02*c2 + r03*c3 + r04*c4 + r05*c5 + r06*c6 + r07*c7 + r08*c8 + r09*c9;
                a[i+1][j] += r10*c0 + r11*c1 + r12*c2 + r13*c3 + r14*c4 + r15*c5 + r16*c6 + r17*c7 + r18*c8 + r19*c9;
                a[i+2][j] += r20*c0 + r21*c1 + r22*c2 + r23*c3 + r24*c4 + r25*c5 + r26*c6 + r27*c7 + r28*c8 + r29*c9;
                a[i+3][j] += r30*c0 + r31*c1 + r32*c2 + r33*c3 + r34*c4 + r35*c5 + r36*c6 + r37*c7 + r38*c8 + r39*c9;
                a[i+4][j] += r40*c0 + r41*c1 + r42*c2 + r43*c3 + r44*c4 + r45*c5 + r46*c6 + r47*c7 + r48*c8 + r49*c9;
                a[i+5][j] += r50*c0 + r51*c1 + r52*c2 + r53*c3 + r54*c4 + r55*c5 + r56*c6 + r57*c7 + r58*c8 + r59*c9;
                a[i+6][j] += r60*c0 + r61*c1 + r62*c2 + r63*c3 + r64*c4 + r65*c5 + r66*c6 + r67*c7 + r68*c8 + r69*c9;
                a[i+7][j] += r70*c0 + r71*c1 + r72*c2 + r73*c3 + r74*c4 + r75*c5 + r76*c6 + r77*c7 + r78*c8 + r79*c9;
                a[i+8][j] += r80*c0 + r81*c1 + r82*c2 + r83*c3 + r84*c4 + r85*c5 + r86*c6 + r87*c7 + r88*c8 + r89*c9;
                a[i+9][j] += r90*c0 + r91*c1 + r92*c2 + r93*c3 + r94*c4 + r95*c5 + r96*c6 + r97*c7 + r98*c8 + r99*c9;
                
                a[i+10][j] += r100*c0 + r101*c1 + r102*c2 + r103*c3 + r104*c4 + r105*c5 + r106*c6 + r107*c7 + r108*c8 + r109*c9;
                a[i+11][j] += r110*c0 + r111*c1 + r112*c2 + r113*c3 + r114*c4 + r115*c5 + r116*c6 + r117*c7 + r118*c8 + r119*c9;
                a[i+12][j] += r120*c0 + r121*c1 + r122*c2 + r123*c3 + r124*c4 + r125*c5 + r126*c6 + r127*c7 + r128*c8 + r129*c9;
                a[i+13][j] += r130*c0 + r131*c1 + r132*c2 + r133*c3 + r134*c4 + r135*c5 + r136*c6 + r137*c7 + r138*c8 + r139*c9;
                a[i+14][j] += r140*c0 + r141*c1 + r142*c2 + r143*c3 + r144*c4 + r145*c5 + r146*c6 + r147*c7 + r148*c8 + r149*c9;
                a[i+15][j] += r150*c0 + r151*c1 + r152*c2 + r153*c3 + r154*c4 + r155*c5 + r156*c6 + r157*c7 + r158*c8 + r159*c9;
                a[i+16][j] += r160*c0 + r161*c1 + r162*c2 + r163*c3 + r164*c4 + r165*c5 + r166*c6 + r167*c7 + r168*c8 + r169*c9;
                a[i+17][j] += r170*c0 + r171*c1 + r172*c2 + r173*c3 + r174*c4 + r175*c5 + r176*c6 + r177*c7 + r178*c8 + r179*c9;
                a[i+18][j] += r180*c0 + r181*c1 + r182*c2 + r183*c3 + r184*c4 + r185*c5 + r186*c6 + r187*c7 + r188*c8 + r189*c9;
                a[i+19][j] += r190*c0 + r191*c1 + r192*c2 + r193*c3 + r194*c4 + r195*c5 + r196*c6 + r197*c7 + r198*c8 + r199*c9;

                
            }
            
        }
	in_end = time(NULL);
	in_total += in_end - in_beg;
	++in_i;
    }




    endtime=rdtsc();                         //getting time and number of
    end=clock();                             //cycles before the execution

    printf("\nSize: %d\n",N);
    printf("Number of clocks: %Lu\n" ,endtime-starttime);
    printf("Time: %ld\n\n", end-beg);
    std::cout << "in_total:\t" << in_total << std::endl;
    std::cout << "in_it:\t" << in_i << std::endl;


    //checking correctness of the matrix

    if (argc == 3){
        if (*argv[2]=='c'){
        
            double x[N][N];
        
            for( i=0; i<N; i++)
                for( j=0; j<N; j++)
                    x[i][j]=0;
            
            for( i=0; i<N; i++)
                for( j=0; j<N; j++)
                    for( k=0; k<N; k++)
                        x[i][j] += b[i][k]*c[k][j];
            
            
            for(i=0;i<N;i++){
                for(j=0;j<N;j++){
                    if ((a[i][j] >= (x[i][j]+0.05)) || (a[i][j] <= (x[i][j]-0.05))){
                        printf("\nincorrect\n, %d %d\n",i,j);
                        exit(1);
                    }
                }
            }
            printf("\ncorrect\n\n");
        }
    }
}
