#!/usr/bin/perl

use Getopt::Long;

GetOptions(	"sample=i"	=> \$sample_size,
		"processors=i"	=> \$max_processors,
		"file=s"	=> \$file,
		"command=s"	=> \$command);

$format = "\%Uu \%Ss \%E";
@all_commands = split(/ /, $command);
$kill_command = $all_commands[0];

open(OUTPUT, ">>$file");

for (my $p = 1; $p <= $max_processors; ++$p) {
	
	print OUTPUT "# $p:\n";
	print "$p: ";

	$exec_command = $command;
	$exec_command =~ s/_/$p/;

	for (my $s = 0; $s < $sample_size; ++$s) {
		
		if (system("/usr/bin/time --format=\"$format\" --output=$file --append $exec_command")) {
			print OUTPUT "\tERROR.\n";
			system("pkill -9 $kill_command");
		}
		print "$s ";
	}
	print OUTPUT "\n";
	print "\n";
}

