#ifndef __SYNCHRO_ATOMIC_H__
#define __SYNCHRO_ATOMIC_H__

#define __fool_gcc(x) (*(struct {unsigned int a[100];} *)x)

inline unsigned long fetch_and_store(volatile unsigned long *address, long value);
inline void atmc_add(volatile unsigned long *address, long value);
inline unsigned long atmc_fetch_and_add(volatile unsigned long *address, long value);

inline unsigned long compare_and_swap(volatile unsigned long *address,
				      unsigned long old_value,
				      unsigned long new_value);

inline unsigned long compare_and_swap8b(volatile unsigned long long *address,
					unsigned long old_value_low,
					unsigned long old_value_high,
					unsigned long new_value_low,
					unsigned long new_value_high);
/***************************************************************************/

#define fetch_and_store(address, value) \
({ \
 volatile unsigned long ret_val; \
\
 __asm__ __volatile__ ("lock; xchgl %0, %1" \
 		       :"=r" ((ret_val)) \
 		       :"m" (__fool_gcc((address))), "0" ((value)) \
 		       :"memory"); \
 ret_val; \
})

#define atmc_add(address, value) \
({ \
  register volatile long val = (value); \
\
  __asm__ __volatile__ ("lock; addl %1, %0" \
  			: "=m" (*(address)) \
  			: "r" (val)); \
})

#if 0
/* This version does not work due to a bug in 3.3.x gcc compilers... *  \
 * Using an uninitialized register as an argument to xaddl if -O2 or *  \
 * -O3 optimization levels are used				     */ \
#define atmc_fetch_and_add(address, value) \
({ \
  register volatile unsigned long val = (value); \
\
  __asm__ __volatile__ ("lock; xaddl %0, %1" \
  			: "=r" (val), "=m" (*(address)) \
  			: "r" (val) \
  			: "memory", "cc");\
\
 val; \
})
#else
#define atmc_fetch_and_add(address, value) \
({ \
  register volatile unsigned long val = (value); \
\
  /*printf("In atmc_fetch_and_add before. Address = %p, *address = %lu, val = %lu\n", address, *(unsigned long *)address, value);*/\
  __asm__ __volatile__ ("lock\n\t" \
  			"xaddl %%ecx, %1" \
  			: "=c" (val), "=m" (*(address)) \
  			: "c" (val) \
  			: "memory", "cc");\
\
  /*printf("In atmc_fetch_and_add after. Address = %p, *address = %lu, val = %lu\n", address, *(unsigned long *)address, value);*/\
 val; \
})
#endif

#define compare_and_swap(address, old_value, new_value) \
({ \
  unsigned long ret_val = 0; \
  __asm__ __volatile__ ("lock\n\t" \
  			"cmpxchgl %2, (%1)\n\t" \
  			"sete (%3)\n\t" \
  			: \
  			: "a" (old_value), "r" (address), "r" (new_value), \
  			  "r" (&ret_val) \
  			: "memory"); \
  ret_val; \
})

#define compare_and_swap8b(address, old_value_low, old_value_high, \
			   new_value_low, new_value_high) \
({ \
  unsigned long ret_val = 0; \
  __asm__ __volatile__ ("lock\n\t" \
  			"cmpxchg8b (%0)\n\t" \
  			"sete (%1)\n\t" \
  			: \
  			: "r" (address), "r" (&ret_val), \
  			  "d" (old_value_high), "a" (old_value_low), \
  			  "c" (new_value_high), "b" (new_value_low) \
  			: "memory"); \
  ret_val; \
 })

#endif	// __SYNCHRO_ATOMIC_H__

