#include <iostream>
#include <queue>
#include <cassert>
using namespace std;

#include "simple_deque.h"

int main()
{
	simple_deque<char> dq;
	simple_deque<int> idq;

	assert(dq.empty());
	dq.push_back('a');
	dq.push_back('b');
	dq.push_back('c');
	dq.push_back('d');
	dq.push_back('e');
	assert(dq.size() == 5);
	assert(!dq.empty());

	assert(dq.front() == 'a');
	dq.pop_front();
	assert(dq.size() == 4);
	assert(!dq.empty());

	assert(dq.front() == 'b');
	dq.pop_front();
	assert(dq.size() == 3);
	assert(!dq.empty());

	assert(dq.front() == 'c');
	dq.pop_front();
	assert(dq.size() == 2);
	assert(!dq.empty());

	assert(dq.front() == 'd');
	dq.pop_front();
	assert(dq.size() == 1);
	assert(!dq.empty());

	assert(dq.front() == 'e');
	dq.pop_front();
	assert(dq.size() == 0);
	assert(dq.empty());

	dq.push_front('f');
	dq.push_front('g');
	dq.push_front('h');
	dq.push_front('i');
	assert(dq.size() == 4);
	assert(!dq.empty());

	assert(dq.front() == 'i');
	assert(!dq.empty());
	dq.pop_front();

	assert(dq.front() == 'h');
	assert(!dq.empty());
	dq.pop_front();

	assert(dq.back() == 'f');
	assert(!dq.empty());
	dq.pop_back();

	assert(dq.back() == 'g');
	assert(dq.front() == 'g');
	assert(dq.size() == 1);
	assert(!dq.empty());

	assert(idq.empty());
	for (int i = 0; i < 10000; ++i) {
		idq.push_back(i);
		assert(idq.back() == i);
	}
	assert(!idq.empty());

	for (int i = 0; i < 10000 ; ++i) {
		assert(idq.front() == i);
		idq.pop_front();
	}
	assert(idq.empty());

	return 0;
}
